#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include <stdarg.h>

#include <vector>
#include <string>

#include <locale>
#include <amsstring/amsstring.hpp>

using namespace ams;
using namespace std;

namespace ams
{

  int localmin(int a, int b);
  int localmax(int a, int b);

int localmin(int a, int b)
{
  int ret;
  if(a<b) ret = a;
  else ret = b;
  return ret;
}

int localmax(int a, int b)
{
  int ret;
  if(a>b) ret = a;
  else ret = b;
  return ret;
}

int localstrlen(const ams_chartype *c)
{
  return strlen((const char*) c);
}

amsstring::amsstring()
{
    cstring = new ams_chartype[1];
    cstring[0] = '\0';
    length = 0;
    return;
}

amsstring::amsstring(int _length)
{
    amsstring(_length,' ');
    return;
}

amsstring::amsstring(int _length, const ams_chartype initchar)
{
    int I;

    length = _length;
    cstring = NULL;
    cstring  = new ams_chartype[length+1];

    if(cstring==NULL)
    {
      printf("Error in amsstring constructor: String failed to initialize\n");
      exit(1);
    }
    else
    {
      for(I=0;I<length;I++)
      {
        cstring[I] = initchar;
      }
      cstring[length] = '\0'; //a step added to keep all strings created by this method valid
    }
    return;
}

amsstring::amsstring(const ams_chartype *inpstr)
{
    length = ams::localstrlen(inpstr);

    cstring = NULL;
    cstring  = new ams_chartype[length+1];
    if(cstring==NULL)
    {
      printf("Error in amsstring constructor: String failed to initialize\n");
      exit(1);
    }
    else
    {
      amsstrcpy_s(cstring,length+1,inpstr);
      cstring[length] = '\0'; //a step added to keep all strings created by this method valid
    }

    return;
}

amsstring::~amsstring()
{
    delete[] cstring;
    length = 0;
    return;
}

int amsstring::size()
{
    int ret = length;
    return ret;
}

void amsstring::resize(int N)
{
    int I;
    int oldlength = length;
    ams_chartype *oldstr = new ams_chartype[length+1];
    memcpy((void *) oldstr, (void *) cstring, length+1);

    delete[] cstring;
    length = N;
    cstring  = new ams_chartype[length+1];
    if(cstring==NULL)
    {
      printf("Error in amsstring constructor: String failed to initialize\n");
      exit(1);
    }
    else
    {
      for(I=0;I<localmin(oldlength,length);I++)
      {
        cstring[I] = oldstr[I];
      } //could probably replace with memcpy
      for(I=oldlength;I<length;I++)
      {
        cstring[I] = ' ';
      }
      cstring[length] = '\0'; //a step added to keep all strings created by this method valid
    }

    delete[] oldstr;

    return;
}

void amsstring::clear()
{
    length = 0;
    delete[] cstring;
    cstring = new ams_chartype[1];
    cstring[0] = '\0';
    return;
}

const ams_chartype* amsstring::c_str()
{
    return cstring;
}

amsstring::amsstring(const amsstring &other)
{
  cstring = new ams_chartype[1];
  cstring[0] = '\0';
  length = 0;
  if(this!=&other)
  {
    this->copy(&other);
  }
  return;
}

amsstring& amsstring::operator=(const amsstring &other)
{
  if(this!=&other)
  {
    delete cstring;
    cstring = NULL;
    length = other.length;
    cstring = new ams_chartype[other.length+1];
    memcpy((void*)cstring,(void*)(other.cstring),sizeof(ams_chartype)*length);
    cstring[length] = '\0';
  }
  return *this;
}

amsstring& amsstring::operator=(const char *other)
{
  delete cstring;
  cstring = NULL;
  length = ::strlen(other);
  cstring = new ams_chartype[length+1];
  memcpy((void*)cstring,(void*)(other),sizeof(ams_chartype)*length);
  cstring[length] = '\0';

  return *this;
}


void amsstring::copy(const amsstring *other)
{
    if(this!=other)
    {
    this->resize(other->length);
    memcpy((void*)cstring,(void*)(other->cstring),sizeof(ams_chartype)*length);
    cstring[length]='\0';
    }
    return;
}

void amsstring::copy(amsstring *other)
{
    if(this!=other)
    {
    this->resize(other->length);
    memcpy((void*)cstring,(void*)(other->cstring),sizeof(ams_chartype)*length);
    cstring[length]='\0';
    }
    return;
}

void amsstring::copy(std::string *other)
{
    this->copy(other->c_str());
    return;
}

void amsstring::copy(const ams_chartype *other)
{
    int N = ams::localstrlen(other);
    this->resize(N);
    memcpy((void*)cstring,(void*)other,sizeof(ams_chartype)*length);
    cstring[length]='\0';
    return;
}

void amsstring::substring(int ind1, int ind2, amsstring *sout)
{
    int I;
    if(ind2>=ind1)
    {
      sout->resize(ind2-ind1+1);
      for(I=ind1;I<=ind2;I++)
      {
        if(I>=0&&I<this->length)
        {
          sout->cstring[I-ind1] = this->cstring[I];
        }
        else
        {
          sout->cstring[I-ind1] = ' ';
        }
      }
      sout->cstring[sout->length] = '\0';
    }
    else
    {
      sout->resize(0);
    }
    return;
}

ams_chartype& amsstring::at(int ind)
{

    return (cstring[ind]);
}

void amsstring::setblank()
{
  int I;
  for(I=0;I<length;I++)
  {
    cstring[I]=' ';
  }
  cstring[length] = '\0';
  return;
}

void amsstring::insert(int ind, amsstring *strtoins)
{
    amsstring oldstring;
    oldstring.copy(this);
    int oldlength = oldstring.length;
    int I,J,K;
    int newlength;
    if(ind<0)
    {
      //don't handle this situation right now
      return;
    }
    else if(ind>=0&&ind<=oldlength)
    {
      //index points to a place within the old string
      newlength = oldlength+strtoins->length;
      resize(newlength);
      setblank(); //sets all characters to blank
      for(I=0;I<ind;I++)
      {
        cstring[I] = oldstring.cstring[I];
      }
      for(I=ind;I<ind+strtoins->length;I++)
      {
        cstring[I] = strtoins->cstring[I-ind];
      }
      for(I=ind+strtoins->length;I<oldlength+strtoins->length;I++)
      {
        cstring[I] = oldstring.cstring[I-strtoins->length];
      }
      cstring[length] = '\0';
    }
    else
    {
      //index points to something outside current string - expand to fit, fill other spaces with ' '
      newlength = (ind-oldlength)+oldlength+strtoins->length;
      resize(newlength);
      setblank(); //sets all characters to blank
      for(I=0;I<oldlength;I++)
      {
        cstring[I] = oldstring.cstring[I];
      }
      for(I=ind;I<ind+strtoins->length;I++)
      {
        cstring[I] = strtoins->cstring[I-ind];
      }
      cstring[length] = '\0';
    }

    return;
}

void amsstring::insert(int ind, const ams_chartype *strtoins)
{
    amsstring q;
    q.copy(strtoins);
    insert(ind,&q);
    return;
}

void amsstring::insert(int ind, amsstring strtoins)
{
    insert(ind,&strtoins);
    return;
}

void amsstring::remove(int ind)
{
    if(ind>=0&&ind<length)
    {
      amsstring q;
      q.copy(this);
      this->resize(length-1);
      int I;
      for(I=0;I<ind;I++)
      {
        cstring[I] = q.cstring[I];
      }
      for(I=ind;I<length;I++)
      {
        cstring[I] = q.cstring[I+1];
      }
      cstring[length] = '\0';
    }
    return;
}


void amsstring::remove(int ind1, int ind2)
{
  int i1_2 = localmax(0,ind1);
  int i2_2 = localmin(ind2,length-1);
  amsstring oldstring;
  oldstring.copy(this);
  int I;

  this->resize(length-(i2_2-i1_2+1));
  int K = 0;
  for(I=0;I<i1_2;I++)
  {
    cstring[K] = oldstring.cstring[I];
    K = K + 1;
  }
  for(I=i2_2+1;I<oldstring.length;I++)
  {
    cstring[K] = oldstring.cstring[I];
    K = K + 1;
  }
  cstring[length] = '\0';
  return;
}

int amsstring::sprintf(int bufflen, const ams_chartype *formatstring, ...)
{
    int ret = 0;
    ams_chartype buff[bufflen];
    va_list varargs;

    va_start(varargs,formatstring);
    vsnprintf(buff,bufflen-1,formatstring,varargs);
    va_end(varargs);

    int N = ams::localstrlen(buff);
    this->copy(buff);

    return ret;
}


void amsstring::append(amsstring *other)
{
    int I;
    amsstring oldstring;
    int oldlength = length;
    this->resize(oldlength+other->length);
    for(I=0;I<other->length;I++)
    {
      cstring[I+oldlength] = other->cstring[I];
    }
    cstring[length] = '\0';
    return;
}

void amsstring::append(const ams_chartype c)
{
  int oldlength = length;
  this->resize(oldlength+1);
  //printf("debug: oldlength=%d, length=%d, c=%c\n",oldlength,length,c);
  cstring[oldlength] = c;
  cstring[oldlength+1] = '\0';

  return;
}

void amsstring::append(const ams_chartype *s)
{
    amsstring s2;
    s2.copy(s);
    append(&s2);
    return;
}

void amsstring::append(amsstring s)
{
    append(&s);
    return;
}

void amsstring::append(int i)
{
    ams_chartype s[500];
    amssprintf_s(s,500,"%d",i);
    append(s);
    return;
}

void amsstring::append(double d)
{
    ams_chartype s[500];
    if(isnan(d))
    {
      amssprintf_s(s,500,"nan");
    }
    else if(isinf(d))
    {
      if(signbit(d))
      {
        amssprintf_s(s,500,"-inf");
      }
      else
      {
        amssprintf_s(s,500,"inf");
      }
    }
    else
    {
      amssprintf_s(s,500,"%1.6g",d);
    }
    append(s);
    return;
}


bool amsstring::isvalidnumber()
{
  bool ret = ams_isvalidnumber(cstring);
  return ret;
}

ams_chartype tolower(ams_chartype c)
{
  unsigned char c2 = (unsigned char) c;
  ams_chartype ret;
  if(c2>=65&&c2<=90)
  {
    ret = (ams_chartype) (c2+(97-65));
  }
  else
  {
    ret = c;
  }
  return ret;
}

ams_chartype toupper(ams_chartype c)
{
  unsigned char c2 = (unsigned char) c;
  ams_chartype ret;
  if(c2>=97&&c2<=122)
  {
    ret = (ams_chartype) (c2-(97-65));
  }
  else
  {
    ret = c;
  }
  return ret;
}

void amsstring::tolower()
{
  std::locale loc;

  int I;
  for(I=0;I<length;I++)
  {
    cstring[I] = (ams_chartype) ams::tolower(cstring[I]);
  }
  return;
}

void amsstring::toupper()
{
  int I;
  for(I=0;I<length;I++)
  {
    cstring[I] = (ams_chartype) ams::toupper(cstring[I]);
  }
  return;
}


double amsstring::str2double()
{
    double ret = amsstrtod(cstring);
    return ret;
}

int amsstring::str2int()
{
    int ret = strtol(cstring,NULL,0);
    return ret;
}


int amsstring::find(amsstring substr, int indstart, bool casesens)
{
    int ret = -1;
    ret = find(substr.cstring,indstart,casesens);
    return ret;
}

int amsstring::find(const ams_chartype c, int indstart,bool casesens)
{
    int I;
    int ret = -1;
    for(I=indstart;I<length;I++)
    {
      if(casesens&&(cstring[I]==c)||(!casesens)&&(ams::tolower(cstring[I])==ams::tolower(c)))
      {
        ret = I;
        break;
      }
    }
    return ret;
}

int amsstring::find(amsstring *substr, int indstart, bool casesens)
{
    int ret = -1;
    ret = find(substr->cstring,indstart,casesens);
    return ret;
}

int amsstring::find(const ams_chartype *str, int indstart, bool casesens)
{
    int I;
    int ret = -1;
    int J = 0;
    int N = ams::localstrlen(str);
    bool cs;
    ams_chartype c1,c2;

    int mode=0;
    bool qf = 0;
    bool beq;

    I = 0;
    J = 0;
    while(I<length&&qf==0)
    {
      c1 = cstring[I];
      c2 = str[J];
      cs = 0;
      beq = casesens&&(cstring[I]==str[J]) || ((!casesens)&&(ams::tolower(cstring[I])==ams::tolower(str[J])));

      if(mode==0&&beq)
      {
        mode = 1;
      }
      if(mode==0&&!beq)
      {
        cs = 1;
      }
      if(mode==1&&beq)
      {
        cs = 1;
        J = J + 1;
      }
      if(mode==1&&!beq)
      {
          J = 0;
          cs = 0;
          mode = 0;
      }

      //printf("N:%d I:%d J:%d beq:%d c1:%c c2:%c\n",N,I,J,beq,c1,c2);

      if(J>=N)
      {
        ret = I-N+1;
        qf = 1;
        break;
      }

      if(cs)
      {
        I = I + 1;
      }
    }



    // for(I=indstart;I<length;I++)
    // {
    //   printf("N:%d str[%d]=%c cstr[%d]=%c equal?%d\n",N,J,str[J],I,cstring[I],cstring[I]==str[J]);
    //   if( (casesens&&(cstring[I]==str[J])) || ((!casesens)&&(ams::tolower(cstring[I])==ams::tolower(str[J]))) )
    //   {
    //     J = J + 1;
    //   }
    //   else
    //   {
    //     J = 0;
    //   }
    //   if(J>=N)
    //   {
    //     ret = I-N+1;
    //     break;
    //   }
    // }
    return ret;
}

void tolower(amsstring *s)
{
  s->tolower();
  return;
}

void toupper(amsstring *s)
{
  s->toupper();
  return;
}

bool amsstring::operator==(const amsstring &other)
{
  bool ret = 0;
  if(this!=&other)
  {
    ret = strneq(this,&other);
  }
  else
  {
    ret = 1;
  }
  return ret;
}

bool amsstring::operator!=(const amsstring &other)
{
  return !((*this)==other);
}

bool amsstring::operator==(const char *other)
{
  bool ret = 0;
  ret = strneq(this,other);
  return ret;
}

bool amsstring::operator!=(const char *other)
{
  return !((*this)==other);
}

static int _local_charcompare(const ams_chartype c1, ams_chartype c2)
{
  int ret = 0;
  //-1 - c1 < c2
  //0 - c1 == c2
  //1 c1 > c2
  unsigned char cc1 = (unsigned char) c1;
  unsigned char cc2 = (unsigned char) c2;
  if(cc1<cc2) ret = -1;
  if(cc1>cc2) ret = 1;
  return ret;
}

bool amsstring::operator<(const amsstring &other)
{
  bool ret = 0;
  bool gt = 0;
  int I;
  for(I=0;I<this->length&&I<other.length;I++)
  {
    if(_local_charcompare(this->cstring[I],other.cstring[I]) == -1)
    {
      ret = 1;
      break;
    }
    if(_local_charcompare(this->cstring[I],other.cstring[I]) == 1)
    {
      ret = 0;
      gt = 1;
      break;
    }
  }
  if(ret==0&&gt==0)
  {
    if(this->length>other.length)
    {
      ret = 0;
    }
    else if(this->length<other.length)
    {
      ret = 1;
    }
    else
    {
      ret = 0; //these are equal strings
    }
  }

  return ret;
}

bool amsstring::operator>(const amsstring &other)
{
  bool ret = 0;
  bool lt = 0;
  int I;
  for(I=0;I<this->length&&I<other.length;I++)
  {
    if(_local_charcompare(this->cstring[I],other.cstring[I]) == -1)
    {
      ret = 0;
      lt = 1;
      break;
    }
    if(_local_charcompare(this->cstring[I],other.cstring[I]) == 1)
    {
      ret = 1;
      break;
    }
  }
  if(ret==0&&lt==0)
  {
    if(this->length>other.length)
    {
      ret = 1;
    }
    else if(this->length<other.length)
    {
      ret = 0;
    }
    else
    {
      ret = 0;
    }
  }

  return ret;
}

ams_chartype& amsstring::operator[](unsigned int ind)
{
  return cstring[ind];
}

bool amsstring::operator<(const ams_chartype *other)
{
  amsstring q = other;
  return (*this)<q;
}

bool amsstring::operator>(const ams_chartype *other)
{
  amsstring q = other;
  return (*this)>q;
}

bool strneq(const amsstring *s1, const amsstring *s2, bool casesens)
{
  bool ret = 0;
  if(s1->length==s2->length)
  {
    int I;
    bool q = 1;
    for(I=0;I<s1->length;I++)
    {
      if(casesens&&(s1->cstring[I]!=s2->cstring[I]) || (!casesens)&&(ams::tolower(s1->cstring[I])!=ams::tolower(s2->cstring[I])))
      {
        q = 0;
        break;
      }
    }
    if(q==1)
    {
      ret = 1;
    }
    else
    {
      ret = 0;
    }
  }
  return ret;
}

bool strneq(const amsstring s1, const amsstring s2, bool casesens)
{
  return strneq(&s1,&s2,casesens);
}

bool strneq(const amsstring s1, const ams_chartype *s2, bool casesens)
{
  amsstring q;
  q.copy(s2);
  return strneq(&s1,&q,casesens);
}
bool strneq(const amsstring *s1, const ams_chartype *s2, bool casesens)
{
  amsstring q;
  q.copy(s2);
  return strneq(s1,&q,casesens);
}

bool strneq(const ams_chartype *s1, const ams_chartype *s2, bool casesens)
{
  bool ret = 0;
  int N1 = ams::localstrlen(s1);
  int N2 = ams::localstrlen(s2);
  if(N1==N2)
  {
    int I;
    bool q = 1;
    for(I=0;I<N1;I++)
    {
      if(casesens&&(s1[I]!=s2[I]) || (!casesens)&&(ams::tolower(s1[I])!=ams::tolower(s2[I])))
      {
        q = 0;
        break;
      }
    }
    if(q==1)
    {
      ret = 1;
    }
    else
    {
      ret = 0;
    }
  }
  return ret;
}

void splitlines(amsstring *s, std::vector<amsstring> *lns)
{
  //windows uses \r\n, linux uses \n as a line delimiter
  int I;
  amsstring q;
  lns->resize(0);
  int ind1 = 0;
  int ind2 = 0;
  int mode = 0;
  int cs;
  I = 0;
  ams_chartype c;


  while(I<s->length)
  {
    c = s->cstring[I];
    cs = 0; //has the character been 'consumed' by the state machine?
    if(c=='\n'&&mode==0&&cs==0)
    {

      cs = 1;
      ind2 = I-1;
      ind2 = localmax(0,ind2);
      s->substring(ind1,ind2,&q);
      lns->push_back(q);
      ind1 = I+1;
      ind2 = I+1;
      ind1 = localmin(s->length,ind1);
      ind2 = localmin(s->length,ind2);
    }
    if(c=='\r'&&mode==0&&cs==0)
    {
      cs = 1;
      mode = 1;
    }
    if(c=='\n'&&mode==1&&cs==0)
    {
      cs = 1;
      ind2 = I-2;
      ind2 = localmax(0,ind2);
      s->substring(ind1,ind2,&q);
      lns->push_back(q);
      ind1 = I+1;
      ind2 = I+1;
      ind1 = localmin(s->length,ind1);
      ind2 = localmin(s->length,ind2);
      mode = 0;
    }
    I = I + 1;
  }
  if(ind1<s->length)
  {
    s->substring(ind1,s->length,&q);
    lns->push_back(q);
  }

  return;
}

void split(amsstring *s, const ams_chartype delimitchar, std::vector<amsstring> *lns)
{
  amsstring q;
  lns->resize(0);


  int I = 0;
  int ind1;
  int ind2;
  int cs;
  ind1 = 0;
  ams_chartype c;
  while(I<s->length)
  {
    c = s->cstring[I];
    cs = 0;
    if(c==delimitchar)
    {
      ind2 = I-1;
      ind2 = localmax(0,ind2);
      s->substring(ind1,ind2,&q);
      lns->push_back(q);
      ind1 = I+1;
      ind2 = I+1;
      ind1 = localmin(s->length-1,ind1);
      ind2 = localmin(s->length-1,ind2);
    }

    I = I + 1;
  }
  if(ind1<s->length&&s->cstring[ind1]!=delimitchar)
  {
    s->substring(ind1,s->length,&q);
    lns->push_back(q);
  }

  return;
}

void split(amsstring *s, const ams_chartype *delimitstr, std::vector<amsstring> *lns)
{
  amsstring q;
  int I = 0;
  int ind1;
  int ind2;
  int ind3;
  int cnt;
  int N = ams::localstrlen(delimitstr);
  int cs;

  ind1 = 0;
  ams_chartype c;
  cnt = 0;
  ind3 = 0;

  lns->resize(0);

  while(I<s->length)
  {
    c = s->cstring[I];
    cs = 0;

    if(c==delimitstr[0])
    {
      ind3 = I;
    }
    if(c==delimitstr[cnt]&&cnt<N)
    {
      cnt = cnt+1;
      cs = 1;
    }
    if(c!=delimitstr[cnt]&&cs==0)
    {
      cnt = 0;
    }
    if(cnt==N)
    {
      ind2 = I-N-1;
      ind2 = localmax(0,ind2);
      s->substring(ind1,ind2,&q);
      lns->push_back(q);
      ind1 = I+1;
      ind2 = I+1;
      cnt = 0;
      ind3 = I+1;
      ind1 = localmin(s->length-1,ind1);
      ind2 = localmin(s->length-1,ind2);
      ind3 = localmin(s->length-1,ind3);
    }

    I = I + 1;
  }
  if(ind1<s->length)
  {
    s->substring(ind1,s->length,&q);
    lns->push_back(q);
  }

  return;
}

void split(amsstring *s, amsstring *delimitstr, std::vector<amsstring> *lns)
{
  split(s,delimitstr->cstring,lns);
  return;
}


void splitwhitespace(amsstring *s, std::vector<amsstring> *lns)
{
  int I;
  int mode;
  ams_chartype c;
  int ind1 = 0;
  int ind2 = 0;
  I = 0;
  mode = 0;
  amsstring q;
  bool qf = 0;

  lns->resize(0);

  while(qf==0)
  {
    c = s->cstring[I];
    if(!(isspace(c)||c==' '||c=='\t')&&mode==0)
    {
      mode = 1;
      ind1 = I;
      ind1 = localmax(0,ind1);
    }
    if((isspace(c)||c==' '||c=='\t'||c=='\0')&&mode==1)
    {
      mode = 0;
      ind2 = I-1;
      ind2 = localmin(ind2,s->length-1);
      s->substring(ind1,ind2,&q);
      printf("debug: %d, %s\n",I,q.cstring);
      lns->push_back(q);
    }
    if(I>=s->length)
    {
      qf = 1;
    }

    I = I + 1;
  }

  return;
}

void stripwhitespace(amsstring *s)
{
  int I;
  amsstring q;
  int ind1 = 0;
  int ind2 = s->length;
  ams_chartype c;
  for(I=0;I<s->length;I++)
  {
    c = s->cstring[I];
    if(!(isspace(c)||c==' '||c=='\t'))
    {
      ind1 = I;
      break;
    }
  }
  for(I=s->length-1;I>=0;I--)
  {
    c = s->cstring[I];
    if(!(isspace(c)||c==' '||c=='\t'))
    {
      ind2 = I;
      break;
    }
  }
  q.copy(s);
  q.substring(ind1,ind2,s);
  return;
}

void stripallwhitespace(amsstring *s)
{
  amsstring q;
  q.resize(s->length);
  int count;
  int I;
  int J;
  J = 0;
  ams_chartype c;
  for(I=0;I<s->length;I++)
  {
    c = s->cstring[I];
    if(!(isspace(c)||c==' '||c=='\t'))
    {
      q.cstring[J] = s->cstring[I];
      J = J + 1;
    }
  }
  q.resize(J);
  q.cstring[q.length]='\0';
  s->copy(&q);
  return;
}

// double str2double(amsstring *s)
// {
//   return s->str2double();
// }
//
// long str2int(amsstring *s)
// {
//   return strtol(s->cstring,NULL,0);
// }

void freadline(FILE *fp,amsstring *s)
{
  const int BUFFSZ = 8000;
  char buff[BUFFSZ];
  int N;

  if(!feof(fp))
  {
  fgets(buff,BUFFSZ,fp);
  N = ams::localstrlen(buff);
  if((N-1)>=0&&(buff[N-1]=='\n'))
  {
    buff[N-1] = '\0';
    N = N - 1;
  }
  if((N-1)>=0&&(buff[N-1]=='\r'))
  {
    buff[N-1] = '\0';
    N = N-1;
  }
  N = ams::localstrlen(buff);
  s->copy(buff);
  }
  else
  {
    s->resize(0);
  }
  return;
}

void freadlines(FILE *fp, std::vector<amsstring> *lines)
{
  amsstring ln;
  while(!feof(fp))
  {
    freadline(fp,&ln);
    lines->push_back(ln);
  }
  return;
}

void fwritelines(FILE *fp, amsstring *s)
{
  fputs(s->cstring,fp);
  return;
}

void freadtxtfile(FILE *fp, amsstring *s)
{
  amsstring q;
  while(!feof(fp))
  {
    freadline(fp,&q);
    if(!feof(fp))
    {
      q.append("\n");
      s->append(q);
    }
  }
  return;
}

};
