#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <ctype.h>
#include <string.h>

#include <limits>

namespace ams
{

int evaldigit(char c)
{
  if(c=='0') return 0;
  else if(c=='1') return 1;
  else if(c=='2') return 2;
  else if(c=='3') return 3;
  else if(c=='4') return 4;
  else if(c=='5') return 5;
  else if(c=='6') return 6;
  else if(c=='7') return 7;
  else if(c=='8') return 8;
  else if(c=='9') return 9;
  else return 0;
  //the dumb way to do this - why doesn't (double)((unsigned char)c-48) work?
  //this may be more general if I end up using a different character type later on
}

//takes ASCII formatted string and converts it to a double precision floating point value
//also handles a few other things: nans and infs
//anything that it cannot parse, it returns (without throwing an error), as a nan
double amsstrtod(const char *str)
{
  double nand = std::numeric_limits<double>::quiet_NaN();
  double inf = std::numeric_limits<double>::infinity();
  double ret = nand; //until further notice

  double predec = 0.0;
  double postdec = 0.0;
  double postdec_denom = 1.0;
  double exponent = 0.0;
  double sgn1 = 1.0;
  double sgn2 = 1.0;

  //if a valid number, ret = (predec+postdec/postdec_denom)*pow(10.0,exponent);
  //perhaps I should be storing bytes instead?
  //x86 uses little endian


  int L = strlen(str);
  int I;
  int qf = 0; //quit flag - stop and parse output
  bool cs = 0;
  char c;
  int mode;

  //mode list
  const static int mode_predecws1 = 1;
  const static int mode_predecsgn = 2;
  const static int mode_predecws2 = 3;
  const static int mode_predecdigit = 4;
  const static int mode_postdecdigit = 5;
  const static int mode_exponentsgn = 6;
  const static int mode_exponentdigit = 7;
  const static int nan1 = 8;
  const static int nan2 = 9;
  const static int nan3 = 10;
  const static int inf1 = 11;
  const static int inf2 = 12;
  const static int inf3 = 13;

  const static bool debug = 0;
  const static bool debug2 = 0;

  //state machines and grammar machines without goto statements are sheer hell...

  mode = mode_predecws1;

  while(I<L&&qf==0)
  {
    c = str[I];
    cs = 0;

    if(mode==mode_predecws1&&cs==0&&I<L&&qf==0)
    {
      if(!isspace(c))
      {
        mode = mode_predecsgn;
      }
    }
    if(mode==mode_predecsgn&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecsgn\n");
      if(c=='.')
      {
        mode = mode_postdecdigit;
        cs = 1;
      }
      else if(c=='+')
      {
        sgn1 = 1.0;
        cs = 1;
        mode = mode_predecws2;
      }
      else if(c=='-')
      {
        sgn1 = -1.0;
        cs = 1;
        mode = mode_predecws2;
      }
      else if(c=='i'||c=='I')
      {
        cs = 1;
        mode = inf1;
      }
      else if(c=='N'||c=='n')
      {
        cs = 1;
        mode = nan1;
      }
      else if(isdigit(c))
      {
        mode = mode_predecdigit;
      }
      else
      {
        mode = -1;
        qf = -1;
        cs = 1;
      }
    }
    if(mode==mode_predecws2&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecws2\n");
      if(c=='.')
      {
        mode = mode_postdecdigit;
        cs = 1;
      }
      else if(isspace(c))
      {
        cs = 1; //do nothing
      }
      else if(c=='i'||c=='I')
      {
        cs = 1;
        mode = inf1;
      }
      else if(c=='N'||c=='n')
      {
        cs = 1;
        mode = nan1;
      }
      else if(isdigit(c))
      {
        mode = mode_predecdigit;
      }
      else
      {
        mode = -1;
        qf = -1;
        cs = 1;
      }
    }
    if(mode==mode_predecdigit&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecdigit\n");
      if(isdigit(c))
      {
        if(predec<0.01&&c=='0')
        {
          cs = 1; //skip leading zeros (predec is a positive or zero integer)
        }
        else
        {
          cs = 1;
          predec = predec*10.0;
          predec = predec + (double)evaldigit(c); //evaluation of ASCII numeral
        }
      }
      else if(isspace(c))
      {
        qf = 1;//valid numeral
        cs = 1;
      }
      else if(c=='E'||c=='e')
      {
        cs = 1;
        mode = mode_exponentsgn;
      }
      else if(c=='.')
      {
        cs = 1;
        mode = mode_postdecdigit;
      }
    }
    if(mode==mode_postdecdigit&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_postdecdigit\n");
      if(isdigit(c))
      {
          cs = 1; //do not skip leading zeros
          postdec = postdec*10.0;
          postdec = postdec + evaldigit(c); //evaluation of ASCII numeral
          postdec_denom = postdec_denom*10.0;
      }
      else if(isspace(c))
      {
        qf = 1;//valid numeral
        cs = 1;
      }
      else if(c=='E'||c=='e')
      {
        cs = 1;
        mode = mode_exponentsgn;
      }
      else
      {
        qf = -1;
        mode = -1;
      }
    }
    if(mode==mode_exponentsgn&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_exponentsgn\n");
      if(c=='+')
      {
        cs = 1;
        sgn2 = 1.0;
        mode = mode_exponentdigit;
      }
      else if(c=='-')
      {
        cs = 1;
        sgn2 = -1.0;
        mode = mode_exponentdigit;
      }
      else if(isdigit(c))
      {
        mode = mode_exponentdigit;
      }
      else
      {
        qf = -1;
        mode = - 1;
      }
    }
    if(mode==mode_exponentdigit&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_exponentdigit\n");
      if(isdigit(c))
      {
        exponent = exponent * 10.0;
        exponent = exponent + evaldigit(c);
      }
      else if(isspace(c))
      {
        qf = 1; //valid character
        cs = 1;
      }
      else
      {
        qf = -1; //invalid character
      }
    }
    if(mode==nan1&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("nan1\n");
      if(c=='a'||c=='A')
      {
        cs = 1;
        mode = nan2;
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==nan2&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("nan2\n");
      if(c=='n'||c=='N')
      {
        qf = -2; //not a number
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==inf1&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("inf1\n");
      if(c=='n'||c=='N')
      {
        cs = 1;
        mode = inf2;
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==inf2&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("inf2\n");
      if(c=='f'||c=='F')
      {
        qf = 2; //infinity
      }
      else
      {
        qf = -1; //invalid number
      }
    }

    I = I + 1;
  } // end while

  if(qf==0||qf==1)
  {
    if(debug2)
    {
      printf("%1.6g*( %1.6g + %1.6g/%1.6g)* 10**(%1.6g*%1.6g)\n",sgn1,predec,postdec,postdec_denom,sgn2,exponent);
    }
    ret = sgn1*(predec+postdec/postdec_denom)*pow(10.0,sgn2*exponent);
  }
  if(qf==2)
  {
    //infinity
    ret = sgn1*inf;
  }

  return ret;
}


//takes ASCII formatted string and checks for numeric validity
//nans given as nan count (even though they're not a number)
//+/- infinity counts
//anything else does not count
bool ams_isvalidnumber(const char *str)
{
  double nand = std::numeric_limits<double>::quiet_NaN();
  double inf = std::numeric_limits<double>::infinity();
  bool ret = 0; //until further notice

  double predec = 0.0;
  double postdec = 0.0;
  double postdec_denom = 1.0;
  double exponent = 0.0;
  double sgn1 = 1.0;
  double sgn2 = 1.0;

  //if a valid number, ret = (predec+postdec/postdec_denom)*pow(10.0,exponent);
  //perhaps I should be storing bytes instead?
  //x86 uses little endian


  int L = strlen(str);
  int I;
  int qf = 0; //quit flag - stop and parse output
  bool cs = 0;
  char c;
  int mode;

  //mode list
  const static int mode_predecws1 = 1;
  const static int mode_predecsgn = 2;
  const static int mode_predecws2 = 3;
  const static int mode_predecdigit = 4;
  const static int mode_postdecdigit = 5;
  const static int mode_exponentsgn = 6;
  const static int mode_exponentdigit = 7;
  const static int nan1 = 8;
  const static int nan2 = 9;
  const static int nan3 = 10;
  const static int inf1 = 11;
  const static int inf2 = 12;
  const static int inf3 = 13;

  const static bool debug = 0;
  const static bool debug2 = 0;

  //state machines and grammar machines without goto statements are sheer hell...

  mode = mode_predecws1;

  while(I<L&&qf==0)
  {
    c = str[I];
    cs = 0;

    if(mode==mode_predecws1&&cs==0&&I<L&&qf==0)
    {
      if(!isspace(c))
      {
        mode = mode_predecsgn;
      }
    }
    if(mode==mode_predecsgn&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecsgn\n");
      if(c=='.')
      {
        mode = mode_postdecdigit;
        cs = 1;
      }
      else if(c=='+')
      {
        sgn1 = 1.0;
        cs = 1;
        mode = mode_predecws2;
      }
      else if(c=='-')
      {
        sgn1 = -1.0;
        cs = 1;
        mode = mode_predecws2;
      }
      else if(c=='i'||c=='I')
      {
        cs = 1;
        mode = inf1;
      }
      else if(c=='N'||c=='n')
      {
        cs = 1;
        mode = nan1;
      }
      else if(isdigit(c))
      {
        mode = mode_predecdigit;
      }
      else
      {
        mode = -1;
        qf = -1;
        cs = 1;
      }
    }
    if(mode==mode_predecws2&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecws2\n");
      if(c=='.')
      {
        mode = mode_postdecdigit;
        cs = 1;
      }
      else if(isspace(c))
      {
        cs = 1; //do nothing
      }
      else if(c=='i'||c=='I')
      {
        cs = 1;
        mode = inf1;
      }
      else if(c=='N'||c=='n')
      {
        cs = 1;
        mode = nan1;
      }
      else if(isdigit(c))
      {
        mode = mode_predecdigit;
      }
      else
      {
        mode = -1;
        qf = -1;
        cs = 1;
      }
    }
    if(mode==mode_predecdigit&&cs==0&&I<L&&qf==0)
    {
      if(debug) printf("mode_predecdigit\n");
      if(isdigit(c))
      {
        if(predec<0.01&&c=='0')
        {
          cs = 1; //skip leading zeros (predec is a positive or zero integer)
        }
        else
        {
          cs = 1;
          predec = predec*10.0;
          predec = predec + (double)evaldigit(c); //evaluation of ASCII numeral
        }
      }
      else if(isspace(c))
      {
        qf = 1;//valid numeral
        cs = 1;
      }
      else if(c=='E'||c=='e')
      {
        cs = 1;
        mode = mode_exponentsgn;
      }
      else if(c=='.')
      {
        cs = 1;
        mode = mode_postdecdigit;
      }
    }
    if(mode==mode_postdecdigit&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_postdecdigit\n");
      if(isdigit(c))
      {
          cs = 1; //do not skip leading zeros
          postdec = postdec*10.0;
          postdec = postdec + evaldigit(c); //evaluation of ASCII numeral
          postdec_denom = postdec_denom*10.0;
      }
      else if(isspace(c))
      {
        qf = 1;//valid numeral
        cs = 1;
      }
      else if(c=='E'||c=='e')
      {
        cs = 1;
        mode = mode_exponentsgn;
      }
      else
      {
        qf = -1;
        mode = -1;
      }
    }
    if(mode==mode_exponentsgn&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_exponentsgn\n");
      if(c=='+')
      {
        cs = 1;
        sgn2 = 1.0;
        mode = mode_exponentdigit;
      }
      else if(c=='-')
      {
        cs = 1;
        sgn2 = -1.0;
        mode = mode_exponentdigit;
      }
      else if(isdigit(c))
      {
        mode = mode_exponentdigit;
      }
      else
      {
        qf = -1;
        mode = - 1;
      }
    }
    if(mode==mode_exponentdigit&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("mode_exponentdigit\n");
      if(isdigit(c))
      {
        exponent = exponent * 10.0;
        exponent = exponent + evaldigit(c);
      }
      else if(isspace(c))
      {
        qf = 1; //valid character
        cs = 1;
      }
      else
      {
        qf = -1; //invalid character
      }
    }
    if(mode==nan1&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("nan1\n");
      if(c=='a'||c=='A')
      {
        cs = 1;
        mode = nan2;
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==nan2&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("nan2\n");
      if(c=='n'||c=='N')
      {
        qf = -2; //not a number
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==inf1&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("inf1\n");
      if(c=='n'||c=='N')
      {
        cs = 1;
        mode = inf2;
      }
      else
      {
        qf = -1; //invalid number
      }
    }
    if(mode==inf2&&cs==0&I<L&&qf==0)
    {
      if(debug) printf("inf2\n");
      if(c=='f'||c=='F')
      {
        qf = 2; //infinity
      }
      else
      {
        qf = -1; //invalid number
      }
    }

    I = I + 1;
  } // end while

  if(qf==0||qf==1)
  {
    ret = 1;
  }
  if(qf==2||qf==-2)
  {
    //infinity
    ret = 1;
  }

  return ret;
}


}
